; LCDBED

.text
.include "allgdef.inc"
.global	Lcdbed

; Eingang: D)lcdpuffer = Ascii-Daten, 0x0 als Endezeichen
;		(D)lcdzgr= zeiger auf lcdpuffer
;		(D)schriftfarbe, (D)hintergrund
;		(D)zeile, (D)spalte = Zeile, Spalte
;		(D)schriftgroessse
;		(D)nachunten, (D)nachrechts = um n Pixel verschieben
;		(B)lcdaktiv = 1

Lcdbed:
	btss	merker,#lcdaktiv
	return
	mov		lcdsta,w0
	bra		w0

	bra		lcdbed0
	bra		lcdbed1
	bra		lcdbed2
	
; Fester setzen
lcdbed0:
	call	Setzefenster
	inc		lcdsta
	return
	
; ein Char komplett zum LCD senden 
lcdbed1:
	call	Charzumtft
	inc	lcdsta
	return
	
; prfen ob alle char im LCD sind
lcdbed2:
	clr		lcdsta
	inc2	lcdzgr
	mov		lcdzgr,w0
	cp0		[w0]      		; Endezeichen?
	bra		z,lcdbed2a      ; ja
 	return
lcdbed2a:
 	bclr	merker,#lcdaktiv	; beenden
 	return

; ======================== UPs ==============================
	 		
; ------------------------------------------------
; 1 Char komplett ins bereits gesetzte Fenster schreiben
; Eingang: Ascii-String in (D)lcdpuffer, Zeiger darauf in (D)lcdzgr
; Farbe ist in (D)schriftfarbe und (D)hintergrund
; Schrift in (D)schriftgroesse (1 bis4)
; ------------------------------------------------

Charzumtft:
	mov		#0x2c,w1
	call	Commandozumtft
	mov		schriftgroesse,w7
	dec		w7,w7				; zum Toggeln / Wiederholen
	clr		w6					; W6 = Reihenzhler
	mov		#psvoffset(font),w5   ; W5 = Zeiger auf Pixel-Reihe
	mov		lcdzgr,w0           ; Zeiger auf ASCII
	mov		[w0],w1  			; char ascii holen nach W1
	mov		#52,w4
	mul.uu	w1,w4,w2           ; W0 x 26 = W2,W3 W2=NW
	add		w5,w2,w5       		; W5 = Zeiger auf 1. Pixel-Reihe

charzumtft1:	
	do		w7,charzumtft1a
	call	Pixelhorizontal
charzumtft1a:
 	nop
 	inc2	w5,w5				; nchstes Fontbyte
	inc		w6,w6				; Bytezhler
	cp		w6,#26
	bra		nz,charzumtft1
	bset	LATB,#lcd_cs 	; ende
	return

; schreibt eine 16bit-Reihe zum TFT-Fenster
; Eingang: Schrift in w7, Font-Byte-Adr in W5
Pixelhorizontal:
	mov		#16,w4				; W4 = Rotierzhler	
	mov		[w5],w2
	swap	w2
pixelh1:
	btsc	w2,#0				; b0 = 1?
	bra		pixelh3
; hintergrundfarbe senden
	do		w7,pixelh2
	mov		hintergrund,w1
	and		#0x00ff,w1
	call	Datenzumtft
	mov		hintergrund,w1
	swap	w1
	and		#0x00ff,w1
	call	Datenzumtft
pixelh2:
 	nop
	bra		pixelh5
; Schriftfarbe senden	
pixelh3:
 	do		w7,pixelh4
	mov		schriftfarbe,w1
	and		#0x00ff,w1
	call	Datenzumtft
	mov		schriftfarbe,w1
	swap	w1
	and		#0x00ff,w1
	call	Datenzumtft
pixelh4:
	nop
; Rotieren
pixelh5:
	rrc		w2,w2           ; Pixelbyte rotieren
	dec		w4,w4			; Rotierzhler
	bra		nz,pixelh1		; nchstes Bit
	return

; ---------------------------------------------
; Sendet die 4 Fensteradressen zum TFT
; Eingang: (D)zeile = Zeilen 0 bis n
;			(D)spalte = Spalte bezogen auf ein
; liegendes Display, oben Y  = Zeile 0, links X = Char 0
;			(D)nachunten = n Pixel nach unten verschieben
;			(D)schriftgroesse 1 bis 4
; ---------------------------------------------
Setzefenster:
	mov		schriftgroesse,w1
	mov		#26,w2
	mul.uu	w1,w2,w4			; Pixel vertikal
	mov		#16,w2
	mul.uu	w1,w2,w8 			; Pixel horizontal
	mov		w4,w9
	
; SC, EC Pixelreihe senkrecht von unten nach oben
	mov		#0x2b,w1
	call	Commandozumtft
	mov		zeile,w2
; Zeile * 26
	mul.su	w2,w9,w4  		; Zeile * Pixelbreite
	mov		nachunten,w5
	add		w4,w5,w4
	swap	w4
	ze		w4,w1			; SC, HW
	call	Datenzumtft
	swap	w4
	ze		w4,w1
	call	Datenzumtft 	; SC, NW
	dec		w9,w3
	add		w4,w3,w4 		; Pixelreihe oben
	swap	w4
	ze		w4,w1
	call	Datenzumtft		; EC, HW
	swap	w4
	ze		w4,w1
	call	Datenzumtft     ; EC, MW
	bset	LATB,#lcd_cs 	; commando  ende
	
; Sp, EP Pixelreihe von links nach rechts
	mov		#0x2a,w1
	call	Commandozumtft
	mov		spalte,w2
	mul.su	w2,w8,w4       	; char * 32			; SP-Adress
	mov		nachrechts,w5
	add		w4,w5,w4
	swap	w4
	ze		w4,w1			; SP, HW
	call	Datenzumtft
	swap	w4
	ze		w4,w1
	call	Datenzumtft 	; SP, NW
	dec		w8,w3
	add		w4,w3,w4		; car*32 + 31
	swap 	w4
	ze		w4,w1
	call	Datenzumtft		; EP, HW
	swap	w4
	ze		w4,w1
	call	Datenzumtft     ; EP, MW
	bset	LATB,#lcd_cs 	; commando  ende
; (D)spalte um ein Char erhhen
	inc		spalte	
	return


		
	
	
	